/*
// Generates our map of lineCode <-> lineName
// TODO: run this as a build step
*/

const fetch = require('node-fetch');
const path = require('path');
const fs = require('fs');

const filePath = path.resolve(__dirname, '../', 'src', 'js', "generated_lines.ts");

async function query(start = 0) {
    const searchParamsStr = new URLSearchParams({
        dataset: "t_troncon_line",
        start
    }).toString();

    const res = await fetch("https://donnees.grandchambery.fr/api/records/1.0/search/?" + searchParamsStr);
    return await res.json();
}

async function main() {
    var totalHits = 0;
    var hitsSeen = 0;

    const namesToCodes = new Map();

    do {
		console.log("fetching, start at", hitsSeen);
        const res = await query(hitsSeen);
        totalHits = res.nhits;
        hitsSeen += res.records.length;

        res.records.forEach(record => {
            namesToCodes.set(record.fields.code_ligne, record.fields.nom_ligne)
        });

        console.log("fetched", hitsSeen, "of", totalHits);
    } while (hitsSeen < totalHits)

    const stops = [];
    for (let [key, value] of namesToCodes) {
        stops.push({lineCode: key, lineName: value});
        //console.log(key, value);
    }

    const str = `/* this file is automatically generated by bin/generateLines.js */

type LineNameCodeMap = {
    lineCode: string,
    lineName: string
};

const lines: LineNameCodeMap[] = ${JSON.stringify(stops, null, 4)};

export default lines;
`;

    console.log("writting to file", filePath);
    fs.writeFileSync(filePath, str, "utf-8");
    console.log("done");
}

main();
